#Datapack for Minecraft 1.14.4 Java Edition
#Created by domain2genus

tag @a[gamemode=survival] add d2g_gamemode_survival
tag @a[gamemode=adventure] add d2g_gamemode_survival
tag @a[gamemode=creative] remove d2g_gamemode_survival
tag @a[gamemode=spectator] remove d2g_gamemode_survival

#Passive mobs only spawn once every 20 seconds. The objective d2g_mobs_time cycles once every 20 seconds, allowing us to replicate this pattern.
	execute if score #d2g_mobs_time_increment d2g_mobs_time = #d2g_mobs_20_seconds d2g_mobs_time as @a[gamemode=!spectator] run function d2g_mobs:required/spawning
	tag @e remove d2g_mobs_newbie
	function d2g_mobs:required/maintain

	execute if score #d2g_mobs_time_increment d2g_mobs_time = #d2g_mobs_20_seconds d2g_mobs_time run scoreboard players set #d2g_mobs_time_increment d2g_mobs_time 0
	scoreboard players add #d2g_mobs_time_increment d2g_mobs_time 1

#Custom smelting recipes, enabled by the NBT Smelting Utility Pack. Each new NBT smelt item requires just the 4 commands in this function.
	execute as @e[tag=d2g_furnace_filling] at @s if block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:0b,tag:{Tags:["d2g_mobs_perch"]}}]} run data modify block ^ ^ ^-1 Items append value {Slot:2b,id:"minecraft:cooked_cod",Count:1b,tag:{Tags:["d2g_mobs_perch"],display:{Name:'{"text":"Cooked Perch","italic":false}'}}}
	execute as @e[tag=d2g_furnace_filling] at @s if block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:0b,tag:{Tags:["d2g_mobs_perch"]}}]} run data merge block ^ ^ ^-1 {CookTime:0s}
	execute as @e[tag=d2g_furnace,tag=!d2g_furnace_empty] at @s if block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:0b,tag:{Tags:["d2g_mobs_perch"]}}]} unless block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:2b,tag:{Tags:["d2g_mobs_perch"]}}]} run data merge block ^ ^ ^-1 {CookTime:0s}
	execute as @e[tag=d2g_furnace,tag=!d2g_furnace_empty] at @s if block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:2b,tag:{Tags:["d2g_mobs_perch"]}}]} unless block ^ ^ ^-1 #d2g_nbt_smelting:furnaces{Items:[{Slot:0b,tag:{Tags:["d2g_mobs_perch"]}}]} run data merge block ^ ^ ^-1 {CookTime:0s}
	
	execute as @e[tag=d2g_campfire_0] at @s if block ^ ^ ^-1 minecraft:campfire{Items:[{Slot:0b,tag:{Tags:["d2g_mobs_perch"]}}]} run data modify block ^ ^ ^-1 Items[{Slot:0b}] set value {Slot:0b,id:"minecraft:cooked_cod",Count:1b,tag:{Tags:["d2g_mobs_perch"],display:{Name:'{"text":"Cooked Perch","italic":false}'}}}
	execute as @e[tag=d2g_campfire_1] at @s if block ^ ^ ^-1 minecraft:campfire{Items:[{Slot:1b,tag:{Tags:["d2g_mobs_perch"]}}]} run data modify block ^ ^ ^-1 Items[{Slot:1b}] set value {Slot:1b,id:"minecraft:cooked_cod",Count:1b,tag:{Tags:["d2g_mobs_perch"],display:{Name:'{"text":"Cooked Perch","italic":false}'}}}
	execute as @e[tag=d2g_campfire_2] at @s if block ^ ^ ^-1 minecraft:campfire{Items:[{Slot:2b,tag:{Tags:["d2g_mobs_perch"]}}]} run data modify block ^ ^ ^-1 Items[{Slot:2b}] set value {Slot:2b,id:"minecraft:cooked_cod",Count:1b,tag:{Tags:["d2g_mobs_perch"],display:{Name:'{"text":"Cooked Perch","italic":false}'}}}
	execute as @e[tag=d2g_campfire_3] at @s if block ^ ^ ^-1 minecraft:campfire{Items:[{Slot:3b,tag:{Tags:["d2g_mobs_perch"]}}]} run data modify block ^ ^ ^-1 Items[{Slot:3b}] set value {Slot:3b,id:"minecraft:cooked_cod",Count:1b,tag:{Tags:["d2g_mobs_perch"],display:{Name:'{"text":"Cooked Perch","italic":false}'}}}
	
#Resets the biome counter when not in overworld
	execute as @a[nbt=!{Dimension:0}] run scoreboard players reset @s d2g_mobs_biomes